
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <conio.h>
#include "astro.h"

/******************************************************************************/
/*@@@s񎮂̌vZ@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */
/******************************************************************************/


void Sum_Matrix_3(Matrix_3 abc,Matrix_3 def,Matrix_3 *ghi)
{
	int i,j;

	for(i=0;i<3;i++){
		for(j=0;j<3;j++)
		ghi->max[j][i]=abc.max[j][i]+def.max[j][i];
		}
}

void Multi_Matrix_3(Matrix_3 abc,Matrix_3 def,Matrix_3 *ghi)
{
	ghi->max[0][0]=abc.max[0][0]*def.max[0][0]+abc.max[0][1]*def.max[1][0]+abc.max[0][2]*def.max[2][0];
	ghi->max[0][1]=abc.max[0][0]*def.max[0][1]+abc.max[0][1]*def.max[1][1]+abc.max[0][2]*def.max[2][1];
	ghi->max[0][2]=abc.max[0][0]*def.max[0][2]+abc.max[0][1]*def.max[1][2]+abc.max[0][2]*def.max[2][2];
	ghi->max[1][0]=abc.max[1][0]*def.max[0][0]+abc.max[1][1]*def.max[1][0]+abc.max[1][2]*def.max[2][0];
	ghi->max[1][1]=abc.max[1][0]*def.max[0][1]+abc.max[1][1]*def.max[1][1]+abc.max[1][2]*def.max[2][1];
	ghi->max[1][2]=abc.max[1][0]*def.max[0][2]+abc.max[1][1]*def.max[1][2]+abc.max[1][2]*def.max[2][2];
	ghi->max[2][0]=abc.max[2][0]*def.max[0][0]+abc.max[2][1]*def.max[1][0]+abc.max[2][2]*def.max[2][0];
	ghi->max[2][1]=abc.max[2][0]*def.max[0][1]+abc.max[2][1]*def.max[1][1]+abc.max[2][2]*def.max[2][1];
	ghi->max[2][2]=abc.max[2][0]*def.max[0][2]+abc.max[2][1]*def.max[1][2]+abc.max[2][2]*def.max[2][2];
}

void Sub_Matrix_3(Matrix_3 abc,Matrix_3 def,Matrix_3 *ghi)
{
	int i,j;

	for(i=0;i<3;i++){
		for(j=0;j<3;j++)
		ghi->max[j][i]=abc.max[j][i]-def.max[j][i];
		}
}

void Multi_Const_Matrix_3(Matrix_3 abc,double a,Matrix_3 *ghi)
{
	int i,j;

	for(i=0;i<3;i++){
		for(j=0;j<3;j++)
		ghi->max[j][i]=a*abc.max[j][i];
		}
}


void Sum_Matrix_1(Matrix_1 ab,Matrix_1 de,Matrix_1 *gh)
{
	int i;

	for(i=0;i<3;i++){
		gh->max[i]=ab.max[i]+de.max[i];
		}
}

void Multi_Matrix_1(Matrix_3 abc,Matrix_1 de,Matrix_1 *gh)
{
	gh->max[0]=abc.max[0][0]*de.max[0]+abc.max[0][1]*de.max[1]+abc.max[0][2]*de.max[2];
	gh->max[1]=abc.max[1][0]*de.max[0]+abc.max[1][1]*de.max[1]+abc.max[1][2]*de.max[2];
	gh->max[2]=abc.max[2][0]*de.max[0]+abc.max[2][1]*de.max[1]+abc.max[2][2]*de.max[2];
}

void Sub_Matrix_1(Matrix_1 ab,Matrix_1 de,Matrix_1 *gh)
{
	int i;

	for(i=0;i<3;i++){
		gh->max[i]=ab.max[i]-de.max[i];
		}
}

void Multi_Const_Matrix_1(Matrix_1 ab,double a,Matrix_1 *gh)
{
	int i;

	for(i=0;i<3;i++){
		gh->max[i]=a*ab.max[i];
		}
}

void Eql_Matrix_1(Matrix_1 ab, Matrix_1 *gh)
{
	int i;

	for(i=0;i<3;i++){
		gh->max[i]=ab.max[i];
		}
}

void Scalar (Matrix_1 ab, double *a)
{
	double sum=0.0;
	int i;

	for(i=0;i<3;i++){
		sum=sum+ab.max[i]*ab.max[i];
		}
	*a= sqrt(sum);
}

void Scalar_Dot (Matrix_1 ab,Matrix_1 de, double *a)
{
	double sum=0.0;
	int i;

	for(i=0;i<3;i++){
		sum=sum+ab.max[i]*de.max[i];
		}
	*a= sum;
}


void Matrix_R1(Matrix_3 abc,double a, Matrix_3 *ghi)
{

			ghi->max[0][0]=  1.0;
			ghi->max[1][0]=  0.0;
			ghi->max[2][0]=  0.0;
			ghi->max[0][1]=  0.0;
			ghi->max[1][1]=  cos(a);
			ghi->max[2][1]= -sin(a);
			ghi->max[0][2]=  0.0;
			ghi->max[1][2]=  sin(a);
			ghi->max[2][2]=  cos(a);
}

void Matrix_R2(Matrix_3 abc,double a, Matrix_3 *ghi)
{

			ghi->max[0][0]=  cos(a);
			ghi->max[1][0]=  0.0;
			ghi->max[2][0]=  sin(a);
			ghi->max[0][1]=  0.0;
			ghi->max[1][1]=  1.0;
			ghi->max[2][1]=  0.0;
			ghi->max[0][2]=  -sin(a);
			ghi->max[1][2]=  0.0;
			ghi->max[2][2]=  cos(a);
}

void Matrix_R3(Matrix_3 abc,double a, Matrix_3 *ghi)
{

			ghi->max[0][0]=  cos(a);
			ghi->max[1][0]=  -sin(a);
			ghi->max[2][0]=  0.0;
			ghi->max[0][1]=  sin(a);
			ghi->max[1][1]=  cos(a);
			ghi->max[2][1]=  0.0;
			ghi->max[0][2]=  0.0;
			ghi->max[1][2]=  0.0;
			ghi->max[2][2]=  1.0;
}

